diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index fb65e2e..a434fe9 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -273,10 +273,11 @@ PG_FUNCTION_INFO_V1(postgres_fdw_handler);
  */
 static void postgresGetForeignRelSize(PlannerInfo *root,
 						  RelOptInfo *baserel,
-						  Oid foreigntableid);
+						  Oid foreigntableid, bool grouped);
 static void postgresGetForeignPaths(PlannerInfo *root,
 						RelOptInfo *baserel,
-						Oid foreigntableid);
+						Oid foreigntableid,
+						bool grouped);
 static ForeignScan *postgresGetForeignPlan(PlannerInfo *root,
 					   RelOptInfo *foreignrel,
 					   Oid foreigntableid,
@@ -341,7 +342,8 @@ static void postgresGetForeignJoinPaths(PlannerInfo *root,
 							RelOptInfo *outerrel,
 							RelOptInfo *innerrel,
 							JoinType jointype,
-							JoinPathExtraData *extra);
+							JoinPathExtraData *extra,
+							bool grouped);
 static bool postgresRecheckForeignScan(ForeignScanState *node,
 						   TupleTableSlot *slot);
 static void postgresGetForeignUpperPaths(PlannerInfo *root,
@@ -352,12 +354,14 @@ static void postgresGetForeignUpperPaths(PlannerInfo *root,
 /*
  * Helper functions
  */
+static void init_pgfdw_baserel_info(PlannerInfo *root, RelOptInfo *rel,
+						Oid foreigntableid, bool grouped);
 static void estimate_path_cost_size(PlannerInfo *root,
 						RelOptInfo *baserel,
 						List *join_conds,
 						List *pathkeys,
-						double *p_rows, int *p_width,
-						Cost *p_startup_cost, Cost *p_total_cost);
+						EstimateInfo * estimates,
+						bool grouped);
 static void get_remote_estimate(const char *sql,
 					PGconn *conn,
 					double *rows,
@@ -404,13 +408,16 @@ static HeapTuple make_tuple_from_result_row(PGresult *res,
 static void conversion_error_callback(void *arg);
 static bool foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel,
 				JoinType jointype, RelOptInfo *outerrel, RelOptInfo *innerrel,
-				JoinPathExtraData *extra);
+				JoinPathExtraData *extra, bool grouped);
 static bool foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel);
+static List *create_remote_agg_tlist(PlannerInfo *root,
+						RelOptInfo *grouped_rel,
+						PathTarget *grouping_target);
 static List *get_useful_pathkeys_for_relation(PlannerInfo *root,
-								 RelOptInfo *rel);
+											  RelOptInfo *rel, bool grouped);
 static List *get_useful_ecs_for_relation(PlannerInfo *root, RelOptInfo *rel);
 static void add_paths_with_pathkeys_for_rel(PlannerInfo *root, RelOptInfo *rel,
-								Path *epq_path);
+								Path *epq_path, bool grouped);
 static void add_foreign_grouping_paths(PlannerInfo *root,
 						   RelOptInfo *input_rel,
 						   RelOptInfo *grouped_rel);
@@ -485,83 +492,51 @@ postgres_fdw_handler(PG_FUNCTION_ARGS)
 static void
 postgresGetForeignRelSize(PlannerInfo *root,
 						  RelOptInfo *baserel,
-						  Oid foreigntableid)
+						  Oid foreigntableid,
+						  bool grouped)
 {
 	PgFdwRelationInfo *fpinfo;
-	ListCell   *lc;
-	RangeTblEntry *rte = planner_rt_fetch(baserel->relid, root);
-	const char *namespace;
-	const char *relname;
-	const char *refname;
+	EstimateInfo *estimates;
 
 	/*
 	 * We use PgFdwRelationInfo to pass various information to subsequent
 	 * functions.
+	 *
+	 * This function can be called twice: first time for plain scan, second
+	 * time for the grouped one. fpinfo should only be initialized once.
 	 */
-	fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
-	baserel->fdw_private = (void *) fpinfo;
-
-	/* Base foreign tables need to be pushed down always. */
-	fpinfo->pushdown_safe = true;
-
-	/* Look up foreign-table catalog info. */
-	fpinfo->table = GetForeignTable(foreigntableid);
-	fpinfo->server = GetForeignServer(fpinfo->table->serverid);
-
-	/*
-	 * Extract user-settable option values.  Note that per-table setting of
-	 * use_remote_estimate overrides per-server setting.
-	 */
-	fpinfo->use_remote_estimate = false;
-	fpinfo->fdw_startup_cost = DEFAULT_FDW_STARTUP_COST;
-	fpinfo->fdw_tuple_cost = DEFAULT_FDW_TUPLE_COST;
-	fpinfo->shippable_extensions = NIL;
-	fpinfo->fetch_size = 100;
-
-	apply_server_options(fpinfo);
-	apply_table_options(fpinfo);
-
-	/*
-	 * If the table or the server is configured to use remote estimates,
-	 * identify which user to do remote access as during planning.  This
-	 * should match what ExecCheckRTEPerms() does.  If we fail due to lack of
-	 * permissions, the query would have failed at runtime anyway.
-	 */
-	if (fpinfo->use_remote_estimate)
+	if (baserel->fdw_private == NULL)
 	{
-		Oid			userid = rte->checkAsUser ? rte->checkAsUser : GetUserId();
-
-		fpinfo->user = GetUserMapping(userid, fpinfo->server->serverid);
+		fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
+		baserel->fdw_private = fpinfo;
+		init_pgfdw_baserel_info(root, baserel, foreigntableid, grouped);
 	}
-	else
-		fpinfo->user = NULL;
 
-	/*
-	 * Identify which baserestrictinfo clauses can be sent to the remote
-	 * server and which can't.
-	 */
-	classifyConditions(root, baserel, baserel->baserestrictinfo,
-					   &fpinfo->remote_conds, &fpinfo->local_conds);
+	fpinfo = (PgFdwRelationInfo *) baserel->fdw_private;
 
-	/*
-	 * Identify which attributes will need to be retrieved from the remote
-	 * server.  These include all attrs needed for joins or final output, plus
-	 * all attrs used in the local_conds.  (Note: if we end up using a
-	 * parameterized scan, it's possible that some of the join clauses will be
-	 * sent to the remote and thus we wouldn't really need to retrieve the
-	 * columns used in them.  Doesn't seem worth detecting that case though.)
-	 */
-	fpinfo->attrs_used = NULL;
-	pull_varattnos((Node *) baserel->reltarget->exprs, baserel->relid,
-				   &fpinfo->attrs_used);
-	foreach(lc, fpinfo->local_conds)
+	if (grouped)
 	{
-		RestrictInfo *rinfo = lfirst_node(RestrictInfo, lc);
+		/*
+		 * baserestrictinfo must be evaluated below the aggregation, so all
+		 * its expressions must be remote.
+		 */
+		if (fpinfo->local_conds != NIL)
+			return;
 
-		pull_varattnos((Node *) rinfo->clause, baserel->relid,
-					   &fpinfo->attrs_used);
+		/*
+		 * Given that there are no local_conds and remote_conds are evaluated
+		 * on the foreign server, baserel->gpi->target is the only thing left
+		 * to check.
+		 *
+		 * XXX Do we need to verify that the target contains no
+		 * PlaceHolderVars?
+		 */
+		if (!foreign_grouping_ok(root, baserel))
+			return;
 	}
 
+	estimates = !grouped ? &fpinfo->est_plain : &fpinfo->est_grouped;
+
 	/*
 	 * Compute the selectivity and cost of the local_conds, so we don't have
 	 * to do it over again for each path.  The best we can do for these
@@ -580,8 +555,8 @@ postgresGetForeignRelSize(PlannerInfo *root,
 	 * when they are set to some sensible costs during one (usually the first)
 	 * of the calls to estimate_path_cost_size().
 	 */
-	fpinfo->rel_startup_cost = -1;
-	fpinfo->rel_total_cost = -1;
+	estimates->rel_startup_cost = -1;
+	estimates->rel_total_cost = -1;
 
 	/*
 	 * If the table or the server is configured to use remote estimates,
@@ -597,13 +572,16 @@ postgresGetForeignRelSize(PlannerInfo *root,
 		 * values in fpinfo so we don't need to do it again to generate the
 		 * basic foreign path.
 		 */
-		estimate_path_cost_size(root, baserel, NIL, NIL,
-								&fpinfo->rows, &fpinfo->width,
-								&fpinfo->startup_cost, &fpinfo->total_cost);
+		estimate_path_cost_size(root, baserel, NIL, NIL, estimates, grouped);
 
 		/* Report estimated baserel size to planner. */
-		baserel->rows = fpinfo->rows;
-		baserel->reltarget->width = fpinfo->width;
+
+		/*
+		 * TODO If grouped, make sure baserel->gpi exists and store the values
+		 * there.
+		 */
+		baserel->rows = estimates->rows;
+		baserel->reltarget->width = estimates->width;
 	}
 	else
 	{
@@ -628,34 +606,8 @@ postgresGetForeignRelSize(PlannerInfo *root,
 		set_baserel_size_estimates(root, baserel);
 
 		/* Fill in basically-bogus cost estimates for use later. */
-		estimate_path_cost_size(root, baserel, NIL, NIL,
-								&fpinfo->rows, &fpinfo->width,
-								&fpinfo->startup_cost, &fpinfo->total_cost);
+		estimate_path_cost_size(root, baserel, NIL, NIL, estimates, grouped);
 	}
-
-	/*
-	 * Set the name of relation in fpinfo, while we are constructing it here.
-	 * It will be used to build the string describing the join relation in
-	 * EXPLAIN output. We can't know whether VERBOSE option is specified or
-	 * not, so always schema-qualify the foreign table name.
-	 */
-	fpinfo->relation_name = makeStringInfo();
-	namespace = get_namespace_name(get_rel_namespace(foreigntableid));
-	relname = get_rel_name(foreigntableid);
-	refname = rte->eref->aliasname;
-	appendStringInfo(fpinfo->relation_name, "%s.%s",
-					 quote_identifier(namespace),
-					 quote_identifier(relname));
-	if (*refname && strcmp(refname, relname) != 0)
-		appendStringInfo(fpinfo->relation_name, " %s",
-						 quote_identifier(rte->eref->aliasname));
-
-	/* No outer and inner relations. */
-	fpinfo->make_outerrel_subquery = false;
-	fpinfo->make_innerrel_subquery = false;
-	fpinfo->lower_subquery_rels = NULL;
-	/* Set the relation index. */
-	fpinfo->relation_index = baserel->relid;
 }
 
 /*
@@ -775,7 +727,8 @@ get_useful_ecs_for_relation(PlannerInfo *root, RelOptInfo *rel)
  * to figure out which pathkeys to consider.
  */
 static List *
-get_useful_pathkeys_for_relation(PlannerInfo *root, RelOptInfo *rel)
+get_useful_pathkeys_for_relation(PlannerInfo *root, RelOptInfo *rel,
+								 bool grouped)
 {
 	List	   *useful_pathkeys_list = NIL;
 	List	   *useful_eclass_list;
@@ -790,12 +743,15 @@ get_useful_pathkeys_for_relation(PlannerInfo *root, RelOptInfo *rel)
 	if (root->query_pathkeys)
 	{
 		bool		query_pathkeys_ok = true;
+		bool		sort_pathkeys_ok = true;
+		PathKey    *pathkey;
+		EquivalenceClass *pathkey_ec;
+		Expr	   *em_expr;
 
 		foreach(lc, root->query_pathkeys)
 		{
-			PathKey    *pathkey = (PathKey *) lfirst(lc);
-			EquivalenceClass *pathkey_ec = pathkey->pk_eclass;
-			Expr	   *em_expr;
+			pathkey = lfirst_node(PathKey, lc);
+			pathkey_ec = pathkey->pk_eclass;
 
 			/*
 			 * The planner and executor don't have any clever strategy for
@@ -815,9 +771,31 @@ get_useful_pathkeys_for_relation(PlannerInfo *root, RelOptInfo *rel)
 				break;
 			}
 		}
-
 		if (query_pathkeys_ok)
 			useful_pathkeys_list = list_make1(list_copy(root->query_pathkeys));
+
+		/*
+		 * If the path is grouped, then it can be sorted by aggregates. These
+		 * are only present in sort_pathkeys.
+		 */
+		if (grouped)
+		{
+			foreach(lc, root->sort_pathkeys)
+			{
+				pathkey = lfirst_node(PathKey, lc);
+				pathkey_ec = pathkey->pk_eclass;
+
+				if (pathkey_ec->ec_has_volatile ||
+					!(em_expr = find_em_expr_for_rel(pathkey_ec, rel)) ||
+					!is_foreign_expr(root, rel, em_expr))
+				{
+					sort_pathkeys_ok = false;
+					break;
+				}
+			}
+			if (sort_pathkeys_ok)
+				useful_pathkeys_list = list_make1(list_copy(root->sort_pathkeys));
+		}
 	}
 
 	/*
@@ -884,12 +862,44 @@ get_useful_pathkeys_for_relation(PlannerInfo *root, RelOptInfo *rel)
 static void
 postgresGetForeignPaths(PlannerInfo *root,
 						RelOptInfo *baserel,
-						Oid foreigntableid)
+						Oid foreigntableid,
+						bool grouped)
 {
 	PgFdwRelationInfo *fpinfo = (PgFdwRelationInfo *) baserel->fdw_private;
 	ForeignPath *path;
+	PathTarget *target = NULL;
 	List	   *ppi_list;
 	ListCell   *lc;
+	List	   *fdw_private;
+	EstimateInfo *estimates;
+
+	if (grouped)
+	{
+		/*
+		 * See postgresGetForeignRelSize().
+		 */
+		if (fpinfo->local_conds != NIL)
+			return;
+
+		/*
+		 * Wasn't it possible to construct remote query?
+		 */
+		if (fpinfo->grouped_tlist == NIL)
+			return;
+
+		/*
+		 * The target must contain aggregates.
+		 */
+		Assert(baserel->gpi != NULL);
+		target = baserel->gpi->target;
+	}
+
+	estimates = !grouped ? &fpinfo->est_plain : &fpinfo->est_grouped;
+
+	/*
+	 * Add information to the paths whether they are grouped or not.
+	 */
+	fdw_private = list_make1(makeInteger(grouped ? 1 : 0));
 
 	/*
 	 * Create simplest ForeignScan path node and add it to baserel.  This path
@@ -899,18 +909,26 @@ postgresGetForeignPaths(PlannerInfo *root,
 	 * to estimate cost and size of this path.
 	 */
 	path = create_foreignscan_path(root, baserel,
-								   NULL,	/* default pathtarget */
-								   fpinfo->rows,
-								   fpinfo->startup_cost,
-								   fpinfo->total_cost,
+								   target,
+								   estimates->rows,
+								   estimates->startup_cost,
+								   estimates->total_cost,
 								   NIL, /* no pathkeys */
 								   NULL,	/* no outer rel either */
 								   NULL,	/* no extra plan */
-								   NIL);	/* no fdw_private list */
-	add_path(baserel, (Path *) path);
+								   fdw_private);
+
+	/*
+	 * Grouped path essentially produces an unique set of grouping
+	 * keys.
+	 */
+	if (grouped)
+		make_uniquekeys_for_agg_path((Path *) path);
+
+	add_path(baserel, (Path *) path, grouped);
 
 	/* Add paths with pathkeys */
-	add_paths_with_pathkeys_for_rel(root, baserel, NULL);
+	add_paths_with_pathkeys_for_rel(root, baserel, NULL, grouped);
 
 	/*
 	 * If we're not using remote estimates, stop here.  We have no way to
@@ -921,6 +939,14 @@ postgresGetForeignPaths(PlannerInfo *root,
 		return;
 
 	/*
+	 * Grouped parameterized path would lead to repeated aggregation, which is
+	 * not too interesting. Since the rest deals only with parameterized
+	 * paths, return now.
+	 */
+	if (grouped)
+		return;
+
+	/*
 	 * Thumb through all join clauses for the rel to identify which outer
 	 * relations could supply one or more safe-to-send-to-remote join clauses.
 	 * We'll build a parameterized path for each such outer relation.
@@ -1052,34 +1078,32 @@ postgresGetForeignPaths(PlannerInfo *root,
 	foreach(lc, ppi_list)
 	{
 		ParamPathInfo *param_info = (ParamPathInfo *) lfirst(lc);
-		double		rows;
-		int			width;
-		Cost		startup_cost;
-		Cost		total_cost;
+		EstimateInfo est_param;
 
 		/* Get a cost estimate from the remote */
+		memset(&est_param, 0, sizeof(EstimateInfo));
 		estimate_path_cost_size(root, baserel,
-								param_info->ppi_clauses, NIL,
-								&rows, &width,
-								&startup_cost, &total_cost);
+								param_info->ppi_clauses, NIL, &est_param,
+								grouped);
 
 		/*
 		 * ppi_rows currently won't get looked at by anything, but still we
 		 * may as well ensure that it matches our idea of the rowcount.
 		 */
-		param_info->ppi_rows = rows;
+		param_info->ppi_rows = est_param.rows;
 
 		/* Make the path */
 		path = create_foreignscan_path(root, baserel,
 									   NULL,	/* default pathtarget */
-									   rows,
-									   startup_cost,
-									   total_cost,
+									   est_param.rows,
+									   est_param.startup_cost,
+									   est_param.total_cost,
 									   NIL, /* no pathkeys */
 									   param_info->ppi_req_outer,
 									   NULL,
-									   NIL);	/* no fdw_private list */
-		add_path(baserel, (Path *) path);
+									   fdw_private);
+
+		add_path(baserel, (Path *) path, grouped);
 	}
 }
 
@@ -1107,13 +1131,39 @@ postgresGetForeignPlan(PlannerInfo *root,
 	List	   *retrieved_attrs;
 	StringInfoData sql;
 	ListCell   *lc;
+	Value	   *grouped_val;
+	bool		grouped;
+
+	Assert(best_path->fdw_private != NIL);
+	grouped_val = (Value *) linitial(best_path->fdw_private);
+	Assert(IsA(grouped_val, Integer));
+	grouped = intVal(grouped_val) == 1;
 
 	if (IS_SIMPLE_REL(foreignrel))
 	{
-		/*
-		 * For base relations, set scan_relid as the relid of the relation.
-		 */
-		scan_relid = foreignrel->relid;
+		if (!grouped)
+		{
+			/*
+			 * For base relations, set scan_relid as the relid of the
+			 * relation.
+			 */
+			scan_relid = foreignrel->relid;
+		}
+		else
+		{
+			/*
+			 * XXX Something seems to be inconsistent here: deparseSelectSql()
+			 * would create the targetlist from foreignrel->gpi->target, but
+			 * not appendGroupByClause(). Try to refactor.
+			 */
+			fdw_scan_tlist = fpinfo->grouped_tlist;
+
+			/*
+			 * The scan tuple descriptor should be constructed from
+			 * fdw_scan_tlist rather than from that of the remote relation.
+			 */
+			scan_relid = 0;
+		}
 
 		/*
 		 * In a base-relation scan, we must apply the given scan_clauses.
@@ -1191,7 +1241,10 @@ postgresGetForeignPlan(PlannerInfo *root,
 		 */
 
 		/* Build the list of columns to be fetched from the foreign server. */
-		fdw_scan_tlist = build_tlist_to_deparse(foreignrel);
+		if (!grouped)
+			fdw_scan_tlist = build_tlist_to_deparse(foreignrel);
+		else
+			fdw_scan_tlist = fpinfo->grouped_tlist;
 
 		/*
 		 * Ensure that the outer plan produces a tuple whose descriptor
@@ -1239,7 +1292,8 @@ postgresGetForeignPlan(PlannerInfo *root,
 	initStringInfo(&sql);
 	deparseSelectStmtForRel(&sql, root, foreignrel, fdw_scan_tlist,
 							remote_exprs, best_path->path.pathkeys,
-							false, &retrieved_attrs, &params_list);
+							false, &retrieved_attrs, &params_list,
+							grouped);
 
 	/* Remember remote_exprs for possible use by postgresPlanDirectModify */
 	fpinfo->final_remote_exprs = remote_exprs;
@@ -2481,6 +2535,124 @@ postgresExplainDirectModify(ForeignScanState *node, ExplainState *es)
 	}
 }
 
+/*
+ * init_pgfdw_rel_info
+ *      Initialize PgFdwRelationInfo and assign it to the base relation. That
+ *      includes estimates, as well as separation of local expressions from
+ *      remote ones.
+ */
+static void
+init_pgfdw_baserel_info(PlannerInfo *root, RelOptInfo *rel,
+						Oid foreigntableid, bool grouped)
+
+{
+	const char *namespace;
+	const char *relname;
+	const char *refname;
+	PgFdwRelationInfo *fpinfo;
+	ListCell   *lc;
+	RangeTblEntry *rte;
+
+	rte = planner_rt_fetch(rel->relid, root);
+	fpinfo = (PgFdwRelationInfo *) rel->fdw_private;
+
+	/*
+	 * Identify which baserestrictinfo clauses can be sent to the remote
+	 * server and which can't.
+	 */
+	classifyConditions(root, rel, rel->baserestrictinfo,
+					   &fpinfo->remote_conds, &fpinfo->local_conds);
+
+	/*
+	 * Identify which attributes will need to be retrieved from the remote
+	 * server.  These include all attrs needed for joins or final output, plus
+	 * all attrs used in the local_conds.  (Note: if we end up using a
+	 * parameterized scan, it's possible that some of the join clauses will be
+	 * sent to the remote and thus we wouldn't really need to retrieve the
+	 * columns used in them.  Doesn't seem worth detecting that case though.)
+	 */
+	fpinfo->attrs_used = NULL;
+	if (!grouped)
+	{
+		pull_varattnos((Node *) rel->reltarget->exprs, rel->relid,
+					   &fpinfo->attrs_used);
+		foreach(lc, fpinfo->local_conds)
+		{
+			RestrictInfo *rinfo = lfirst_node(RestrictInfo, lc);
+
+			pull_varattnos((Node *) rinfo->clause, rel->relid,
+						   &fpinfo->attrs_used);
+		}
+	}
+	else
+	{
+		/*
+		 * deparseExplicitTargetList() is used for the grouped relation, thus
+		 * no need to retrieve attrs_used.
+		 */
+	}
+
+	/* Base foreign tables need to be pushed down always. */
+	fpinfo->pushdown_safe = true;
+
+	/* Look up foreign-table catalog info. */
+	fpinfo->table = GetForeignTable(foreigntableid);
+	fpinfo->server = GetForeignServer(fpinfo->table->serverid);
+
+	/*
+	 * Extract user-settable option values.  Note that per-table setting of
+	 * use_remote_estimate overrides per-server setting.
+	 */
+	fpinfo->use_remote_estimate = false;
+	fpinfo->fdw_startup_cost = DEFAULT_FDW_STARTUP_COST;
+	fpinfo->fdw_tuple_cost = DEFAULT_FDW_TUPLE_COST;
+	fpinfo->shippable_extensions = NIL;
+	fpinfo->fetch_size = 100;
+
+	apply_server_options(fpinfo);
+	apply_table_options(fpinfo);
+
+	/*
+	 * If the table or the server is configured to use remote estimates,
+	 * identify which user to do remote access as during planning.  This
+	 * should match what ExecCheckRTEPerms() does.  If we fail due to lack of
+	 * permissions, the query would have failed at runtime anyway.
+	 */
+	if (fpinfo->use_remote_estimate)
+	{
+		Oid			userid = rte->checkAsUser ? rte->checkAsUser :
+		GetUserId();
+
+		fpinfo->user = GetUserMapping(userid, fpinfo->server->serverid);
+	}
+	else
+		fpinfo->user = NULL;
+
+	/*
+	 * Set the name of relation in fpinfo, while we are constructing it here.
+	 * It will be used to build the string describing the join relation in
+	 * EXPLAIN output. We can't know whether VERBOSE option is specified or
+	 * not, so always schema-qualify the foreign table name.
+	 */
+	fpinfo->relation_name = makeStringInfo();
+	namespace = get_namespace_name(get_rel_namespace(foreigntableid));
+	relname = get_rel_name(foreigntableid);
+	refname = rte->eref->aliasname;
+	appendStringInfo(fpinfo->relation_name, "%s.%s",
+					 quote_identifier(namespace),
+					 quote_identifier(relname));
+	if (*refname && strcmp(refname, relname) != 0)
+		appendStringInfo(fpinfo->relation_name, " %s",
+						 quote_identifier(rte->eref->aliasname));
+
+	/* No outer and inner relations. */
+	fpinfo->make_outerrel_subquery = false;
+	fpinfo->make_innerrel_subquery = false;
+	fpinfo->lower_subquery_rels = NULL;
+	/* Set the relation index. */
+	fpinfo->relation_index = rel->relid;
+}
+
 
 /*
  * estimate_path_cost_size
@@ -2499,8 +2671,8 @@ estimate_path_cost_size(PlannerInfo *root,
 						RelOptInfo *foreignrel,
 						List *param_join_conds,
 						List *pathkeys,
-						double *p_rows, int *p_width,
-						Cost *p_startup_cost, Cost *p_total_cost)
+						EstimateInfo * estimates,
+						bool grouped)
 {
 	PgFdwRelationInfo *fpinfo = (PgFdwRelationInfo *) foreignrel->fdw_private;
 	double		rows;
@@ -2539,8 +2711,13 @@ estimate_path_cost_size(PlannerInfo *root,
 						   &remote_param_join_conds, &local_param_join_conds);
 
 		/* Build the list of columns to be fetched from the foreign server. */
-		if (IS_JOIN_REL(foreignrel) || IS_UPPER_REL(foreignrel))
+		if ((IS_JOIN_REL(foreignrel) && !grouped) || IS_UPPER_REL(foreignrel))
 			fdw_scan_tlist = build_tlist_to_deparse(foreignrel);
+		else if (grouped)
+		{
+			Assert(fpinfo->grouped_tlist != NIL);
+			fdw_scan_tlist = fpinfo->grouped_tlist;
+		}
 		else
 			fdw_scan_tlist = NIL;
 
@@ -2561,7 +2738,7 @@ estimate_path_cost_size(PlannerInfo *root,
 		appendStringInfoString(&sql, "EXPLAIN ");
 		deparseSelectStmtForRel(&sql, root, foreignrel, fdw_scan_tlist,
 								remote_conds, pathkeys, false,
-								&retrieved_attrs, NULL);
+								&retrieved_attrs, NULL, grouped);
 
 		/* Get the remote estimate */
 		conn = GetConnection(fpinfo->user, false);
@@ -2615,15 +2792,17 @@ estimate_path_cost_size(PlannerInfo *root,
 		 * bare scan each time. Instead, use the costs if we have cached them
 		 * already.
 		 */
-		if (fpinfo->rel_startup_cost > 0 && fpinfo->rel_total_cost > 0)
+		if (estimates->rel_startup_cost > 0 && estimates->rel_total_cost > 0)
 		{
-			startup_cost = fpinfo->rel_startup_cost;
-			run_cost = fpinfo->rel_total_cost - fpinfo->rel_startup_cost;
+			startup_cost = estimates->rel_startup_cost;
+			run_cost = estimates->rel_total_cost - estimates->rel_startup_cost;
 		}
 		else if (IS_JOIN_REL(foreignrel))
 		{
-			PgFdwRelationInfo *fpinfo_i;
-			PgFdwRelationInfo *fpinfo_o;
+			PgFdwRelationInfo *fpinfo_i,
+					   *fpinfo_o;
+			EstimateInfo *est_i,
+					   *est_o;
 			QualCost	join_cost;
 			QualCost	remote_conds_cost;
 			double		nrows;
@@ -2632,10 +2811,12 @@ estimate_path_cost_size(PlannerInfo *root,
 			Assert(fpinfo->innerrel && fpinfo->outerrel);
 
 			fpinfo_i = (PgFdwRelationInfo *) fpinfo->innerrel->fdw_private;
+			est_i = !grouped ? &fpinfo_i->est_plain : &fpinfo_i->est_grouped;
 			fpinfo_o = (PgFdwRelationInfo *) fpinfo->outerrel->fdw_private;
+			est_o = !grouped ? &fpinfo_o->est_plain : &fpinfo_o->est_grouped;
 
 			/* Estimate of number of rows in cross product */
-			nrows = fpinfo_i->rows * fpinfo_o->rows;
+			nrows = est_i->rows * est_o->rows;
 			/* Clamp retrieved rows estimate to at most size of cross product */
 			retrieved_rows = Min(retrieved_rows, nrows);
 
@@ -2659,7 +2840,7 @@ estimate_path_cost_size(PlannerInfo *root,
 			 * tables) since we do not know what strategy the foreign server
 			 * is going to use.
 			 */
-			startup_cost = fpinfo_i->rel_startup_cost + fpinfo_o->rel_startup_cost;
+			startup_cost = est_i->rel_startup_cost + est_o->rel_startup_cost;
 			startup_cost += join_cost.startup;
 			startup_cost += remote_conds_cost.startup;
 			startup_cost += fpinfo->local_conds_cost.startup;
@@ -2679,17 +2860,29 @@ estimate_path_cost_size(PlannerInfo *root,
 			 * 4. Run time cost of applying nonpushable other clauses locally
 			 * on the result fetched from the foreign server.
 			 */
-			run_cost = fpinfo_i->rel_total_cost - fpinfo_i->rel_startup_cost;
-			run_cost += fpinfo_o->rel_total_cost - fpinfo_o->rel_startup_cost;
+			run_cost = est_i->rel_total_cost - est_i->rel_startup_cost;
+			run_cost += est_o->rel_total_cost - est_o->rel_startup_cost;
 			run_cost += nrows * join_cost.per_tuple;
 			nrows = clamp_row_est(nrows * fpinfo->joinclause_sel);
 			run_cost += nrows * remote_conds_cost.per_tuple;
 			run_cost += fpinfo->local_conds_cost.per_tuple * retrieved_rows;
 		}
-		else if (IS_UPPER_REL(foreignrel))
+
+		/*
+		 * TODO Consider a separate branch for
+		 *
+		 * (IS_SIMPLE_REL(foreignrel) && * grouped)
+		 *
+		 * and use foreignrel->gpi->target in it instead of
+		 * fpinfo->grouped_tlist.
+		 */
+		else if (IS_UPPER_REL(foreignrel) ||
+				 (IS_SIMPLE_REL(foreignrel) && grouped)
+			)
 		{
 			PgFdwRelationInfo *ofpinfo;
-			PathTarget *ptarget = root->upper_targets[UPPERREL_GROUP_AGG];
+			EstimateInfo *est;
+			PathTarget *ptarget;
 			AggClauseCosts aggcosts;
 			double		input_rows;
 			int			numGroupCols;
@@ -2707,11 +2900,13 @@ estimate_path_cost_size(PlannerInfo *root,
 			 * considering remote and local conditions for costing.
 			 */
 
-			ofpinfo = (PgFdwRelationInfo *) fpinfo->outerrel->fdw_private;
+			ofpinfo = IS_UPPER_REL(foreignrel) ?
+				(PgFdwRelationInfo *) fpinfo->outerrel->fdw_private : fpinfo;
+			est = !grouped ? &ofpinfo->est_plain : &ofpinfo->est_grouped;
 
 			/* Get rows and width from input rel */
-			input_rows = ofpinfo->rows;
-			width = ofpinfo->width;
+			input_rows = est->rows;
+			width = est->width;
 
 			/* Collect statistics about aggregates for estimating costs. */
 			MemSet(&aggcosts, 0, sizeof(AggClauseCosts));
@@ -2736,6 +2931,14 @@ estimate_path_cost_size(PlannerInfo *root,
 			 */
 			rows = retrieved_rows = numGroups;
 
+			if (IS_UPPER_REL(foreignrel))
+				ptarget = root->upper_targets[UPPERREL_GROUP_AGG];
+			else
+			{
+				Assert(foreignrel->gpi != NULL);
+				ptarget = foreignrel->gpi->target;
+			}
+
 			/*-----
 			 * Startup cost includes:
 			 *	  1. Startup cost for underneath input * relation
@@ -2743,7 +2946,7 @@ estimate_path_cost_size(PlannerInfo *root,
 			 *	  3. Startup cost for PathTarget eval
 			 *-----
 			 */
-			startup_cost = ofpinfo->rel_startup_cost;
+			startup_cost = est->rel_startup_cost;
 			startup_cost += aggcosts.transCost.startup;
 			startup_cost += aggcosts.transCost.per_tuple * input_rows;
 			startup_cost += (cpu_operator_cost * numGroupCols) * input_rows;
@@ -2756,7 +2959,7 @@ estimate_path_cost_size(PlannerInfo *root,
 			 *	  3. PathTarget eval cost for each output row
 			 *-----
 			 */
-			run_cost = ofpinfo->rel_total_cost - ofpinfo->rel_startup_cost;
+			run_cost = est->rel_total_cost - est->rel_startup_cost;
 			run_cost += aggcosts.finalCost * numGroups;
 			run_cost += cpu_tuple_cost * numGroups;
 			run_cost += ptarget->cost.per_tuple * numGroups;
@@ -2809,8 +3012,8 @@ estimate_path_cost_size(PlannerInfo *root,
 	 */
 	if (pathkeys == NIL && param_join_conds == NIL)
 	{
-		fpinfo->rel_startup_cost = startup_cost;
-		fpinfo->rel_total_cost = total_cost;
+		estimates->rel_startup_cost = startup_cost;
+		estimates->rel_total_cost = total_cost;
 	}
 
 	/*
@@ -2825,10 +3028,10 @@ estimate_path_cost_size(PlannerInfo *root,
 	total_cost += cpu_tuple_cost * retrieved_rows;
 
 	/* Return results. */
-	*p_rows = rows;
-	*p_width = width;
-	*p_startup_cost = startup_cost;
-	*p_total_cost = total_cost;
+	estimates->rows = rows;
+	estimates->width = width;
+	estimates->startup_cost = startup_cost;
+	estimates->total_cost = total_cost;
 }
 
 /*
@@ -4057,19 +4260,30 @@ postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
  * Assess whether the join between inner and outer relations can be pushed down
  * to the foreign server. As a side effect, save information we obtain in this
  * function to PgFdwRelationInfo passed in.
+ *
+ * Caller expects that the "grouped" argument does not affect the result, so
+ * it's enough to call the function only once per relation. XXX As that
+ * argument is only used in Assert() statement, shouldn't it be removed?
  */
 static bool
 foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel, JoinType jointype,
 				RelOptInfo *outerrel, RelOptInfo *innerrel,
-				JoinPathExtraData *extra)
+				JoinPathExtraData *extra, bool grouped)
 {
-	PgFdwRelationInfo *fpinfo;
-	PgFdwRelationInfo *fpinfo_o;
-	PgFdwRelationInfo *fpinfo_i;
+	PgFdwRelationInfo *fpinfo,
+			   *fpinfo_o,
+			   *fpinfo_i;
 	ListCell   *lc;
 	List	   *joinclauses;
 
 	/*
+	 * TODO
+	 *
+	 * Put the (join-relevant) initial checks of foreign_grouping_ok into a
+	 * function and call it here.
+	 */
+
+	/*
 	 * We support pushing down INNER, LEFT, RIGHT and FULL OUTER joins.
 	 * Constructing queries representing SEMI and ANTI joins is hard, hence
 	 * not considered right now.
@@ -4139,7 +4353,17 @@ foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel, JoinType jointype,
 			if (is_remote_clause)
 				fpinfo->remote_conds = lappend(fpinfo->remote_conds, rinfo);
 			else
+			{
+				/*
+				 * We could return in the grouped case because all clauses
+				 * must be evaluated below the grouping plan (Thus if the
+				 * grouping is remote, those clauses must be remote too.)
+				 * However the same PgFdwRelationInfo is used for both grouped
+				 * and non-grouped case and we don't want to force caller to
+				 * process the non-grouped case first.
+				 */
 				fpinfo->local_conds = lappend(fpinfo->local_conds, rinfo);
+			}
 		}
 	}
 
@@ -4158,9 +4382,26 @@ foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel, JoinType jointype,
 		PlaceHolderInfo *phinfo = lfirst(lc);
 		Relids		relids = joinrel->relids;
 
-		if (bms_is_subset(phinfo->ph_eval_at, relids) &&
-			bms_nonempty_difference(relids, phinfo->ph_eval_at))
-			return false;
+		if (bms_is_subset(phinfo->ph_eval_at, relids))
+		{
+			if (bms_nonempty_difference(relids, phinfo->ph_eval_at))
+			{
+#ifdef USE_ASSERT_CHECKING
+				if (grouped)
+				{
+					/*
+					 * Grouped join shouldn't have PlaceHolderVar even in its
+					 * own targetlist. It'd mean that the output of partial
+					 * aggregation can be set to NULL before it gets to the
+					 * input of the final aggregation.
+					 */
+					Assert(false);
+				}
+#endif							/* USE_ASSERT_CHECKING */
+
+				return false;
+			}
+		}
 	}
 
 	/* Save the join clauses, for later use. */
@@ -4283,14 +4524,6 @@ foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel, JoinType jointype,
 		fpinfo->user = NULL;
 
 	/*
-	 * Set cached relation costs to some negative value, so that we can detect
-	 * when they are set to some sensible costs, during one (usually the
-	 * first) of the calls to estimate_path_cost_size().
-	 */
-	fpinfo->rel_startup_cost = -1;
-	fpinfo->rel_total_cost = -1;
-
-	/*
 	 * Set the string describing this join relation to be used in EXPLAIN
 	 * output of corresponding ForeignScan.
 	 */
